﻿namespace FaceDetection.Evolution
{
  public sealed class LinkGene
  {
    private readonly int id;
    public int Id
    {
      get { return id; }
    }

    private readonly NodeGene from;
    public NodeGene From
    {
      get { return from; }
    }

    private readonly NodeGene to;
    public NodeGene To
    {
      get { return to; }
    }

    public bool IsEnabled { get; set; }

    public bool IsMutable { get; set; }

    public double Weight { get; set; }

    public LinkGene(int id, NodeGene from, NodeGene to)
    {
      this.id = id;
      this.from = from;
      this.to = to;
    }

    public override bool Equals(object obj)
    {
      var other = obj as LinkGene;
      if (other == null)
      {
        return false;
      }
      return id == other.id;
    }

    public override int GetHashCode()
    {
      return id;
    }
  }
}
