﻿namespace FaceDetection.Evolution
{
  public enum NodeType
  {
    RawInput,
    Input,
    Hidden,
    Output
  }

  public sealed class NodeGene
  {
    private readonly int id;
    public int Id
    {
      get { return id; }
    }

    private readonly NodeType type;
    public NodeType Type
    {
      get { return type; }
    }

    private readonly double depth;
    public double Depth
    {
      get { return depth; }
    }

    public NodeGene(int id, NodeType type, double depth)
    {
      this.id = id;
      this.type = type;
      this.depth = depth;
    }

    public override bool Equals(object obj)
    {
      var other = obj as NodeGene;
      if (other == null)
      {
        return false;
      }
      if (id == other.id && !ReferenceEquals(this, obj))
      {
        // Sanity check
        throw new System.Exception();
      }

      return id == other.id;
    }

    public override int GetHashCode()
    {
      return id;
    }
  }
}
